/* code to test quantize functions */
#include <stdio.h>
#include <math.h>

inline double _quantize( double v, int steps ) {
    steps--;
    v = v + 1.0;
    v = v / 2.0;
    v = v * steps;
#ifdef __linux__
    v = rint(v);
#else
    v = round(v);
#endif
    v = v / ((double)steps);
    v = v * 2.0;
    v = v - 1.0;
    return v;
}
#define quantize( v, s ) _quantize( v, s )
inline double nq( double v, int steps ) {
	double s_2;
    steps--;
	s_2 = ((double)steps) / 2.0;
    v = v + 1.0;
    v = v * s_2;
#if 01
	{
		int ti;
		ti = (int)(v + 0.5);
		v = ti;
	}
#elif defined(__linux__)
    v = rint(v);
#else
    v = round(v);
#endif
    v = v / s_2;
    v = v - 1.0;
    return v;
}

int main( int argc, char** argv ) {
	for ( int s = 2; s < 10; s++ ) {
		printf("q( , %d ):\n", s );
		for ( double v = -1.0; v <= 1.0; v += 0.03 ) {
			if ( quantize( v, s ) != nq( v, s ) ) {
				printf("\t%0.4lf=> q %0.4lf , nq %0.4lf\n", v, quantize( v, s ), nq( v, s ) );
			}
		}
		printf("\n");
	}
}
